<# 	
	************************************************************************************************************
	Copyright (c) Microsoft Corporation.  All rights reserved.
	
	Version: 	1.0
	
	Purpose:	Configure Windows Deployment Services (WDS)
	************************************************************************************************************
#>

# *****************************************************************************
# MAIN()
# *****************************************************************************
# Common Processing
# *****************************************************************************

Write-Host "Configuring WDS on server"


wdsutil /initialize-server /reminst:c:\RemoteInstall

if ((get-windowsfeature DHCP).Installed)
{
	Write-Host "WDS and DHCP are co-hosted - configure the WDS server to use a different port"
	WDSUTIL /Set-Server /DHCPOption60:Yes
	Write-Host "INSTALL WDS: Configuring WDS to respond on port 60"
		
	WDSUTIL /Set-Server /UseDHCPPorts:No
}

WDSUTIL /Set-Server /AnswerClients:All
Write-Host "INSTALL WDS: Configuring WDS to respond to all clients"
	

Write-Host "Completed configuration of WDS on server"