﻿<# 	
	************************************************************************************************************
	Copyright (c) Microsoft Corporation.  All rights reserved.
	
	Version: 	1.0
	
	Purpose:	Install Surface App
	************************************************************************************************************
#>



Function Get-ScriptPath
{
    $Invocation = (Get-Variable MyInvocation -Scope 1).Value
    Split-Path $Invocation.MyCommand.Path
}

$AppFolder = Join-Path -Path (Get-ScriptPath) -ChildPath "Source"
If (Test-Path -Path $AppFolder)
{
    $AppFile = (Get-ChildItem -Path $AppFolder -Include "*appxbundle*" -Recurse).FullName
    $Licensefile = (Get-ChildItem -Path $AppFolder -Include "*xml" -Recurse).FullName
    Add-AppxProvisionedPackage -Online -PackagePath $AppFile -LicensePath $Licensefile
}
Else
{
    Write-Host "Source files not found. Skipping installation."
}