﻿<# 	
	************************************************************************************************************
	Copyright (c) Microsoft Corporation.  All rights reserved.
	
	Version: 	1.0
	
	Purpose:	Configure Deployment Share of Microsoft Deploymnet Toolkit
	************************************************************************************************************
#>

Function Get-ScriptPath
{
    $Invocation = (Get-Variable MyInvocation -Scope 1).Value
    Split-Path $Invocation.MyCommand.Path
}

$AppFolder = Join-Path -Path (Get-ScriptPath) -ChildPath "Source"
$AppFile = (Get-ChildItem -Path $AppFolder -Include "*msi" -Recurse).FullName
$InstallArguments =  '  /quiet /norestart /l*v C:\Windows\temp\INSTALL-SurfaceFirmwareTool.log'
If (Test-Path -Path $AppFile)
{    
    Write-Host "Installing Surface Firmware Tool"
    Start-Process -file  $AppFile -arg $InstallArguments -passthru | wait-process
    Write-Host  "$AppName - INSTALLATION SUCCESSFULLY COMPLETED" 
}
Else
{
    Write-Host "Source files not found. Skipping installation."
}


